TalentSwitch = {}

local locked = 0

tLocs = {  { {},{},{},{},{},{} }  ,  { {},{},{},{},{},{} }  }
tsParseEvocation = false
custom = {  {}  ,  {}  }

local specGroup = GetActiveSpecGroup();

-- slash command
SLASH_TSWITCH1 = '/tswitch';
SLASH_TSWITCHJARMODE1 = '/tswitch_jar';
SLASH_TSWITCHCUSTOM1 = '/tswitchadd';
SLASH_TSWITCHLIST1 = '/tswitchlist';
SLASH_TSWITCHDEL1 = '/tswitchdel';
SLASH_TSWITCHTUT1 = '/tswitchhelp';

function SlashCmdList.TSWITCH(msg, editbox)
	print("Command list:\n/tswitchadd - add custom parse rules (see tutorial)\n/tswitchlist - view custom parse rules\n/tswitchdel - delete specified custom parse rule\n/tswitchhelp - display the tutorial/help file.")

	local name, realm = UnitName("player")
	if name == "Jarjour" or name == "Karaashi" then
		print("/tswitch_jar - activate Jarjours special mage mode! (This function is now deprecated, but left in for your convenience)")
	end

end

-- deprecated function for Jarjour!
function SlashCmdList.TSWITCHJARMODE(msg, editbox)

	if msg ~= 'check' then
		tsParseEvocation = not tsParseEvocation 
	end

	if tsParseEvocation == true then
		print("Parsing macros for Evocation if Invocation is selected.")
		TalentSwitch.doMacros()
	else
		print("NOT parsing macros for Evocation if Invocation is selected.")
	end
end

-- event handlers
local function OnWrongEvent(self, event, ...)
	locked = 2 --this thing is to prevent the addon working when talents arent changed, your spec is
end

local function OnMacroChange(self, event, ...)	
	TalentSwitch.doMacros()
end

local function OnEvent(self, event, ...)
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	if InCombatLockdown() then --you never know !
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		return
	end

	 -- if they just changed spec, don't process talents despite the API event
	local checkSpecGroup = GetActiveSpecGroup();
	if checkSpecGroup ~= specGroup then
		specGroup = checkSpecGroup 
		return
	end

	--the API will fire 1 or 2 talent change events we need to ignore just after a talent switch that aren't stopped above
	--assuming 2 will fire is OK, since theres a redundant event when we want to do this for real which will eat up any extra lock
	if locked > 0 then 
		locked = locked -1
	else
		TalentSwitch.doBars()
	end

	-- parse macros no matter what though
	TalentSwitch.doMacros()	
end


-- functions
function TalentSwitch.doMacros()


	local talents = {}
	local active = {}	

	for i = 1, 6 do
		talents[i] = {}
	end


	for i = 1, MAX_NUM_TALENTS do
		local name, iconTexture, tier, column, selected, available = GetTalentInfo(i)

		if tier ~= nil and tier <= 7 and tier >= 0 then
			table.insert(talents[tier], name)
		else
			print(GetTalentInfo(i))
		end

		if selected then
			active[tier] = name
		end
	end



	local general, character = GetNumMacros()
	character = character + 36
	
	for j = 1, general do
		TalentSwitch.sub(j, talents, active)
	end

	for j = 37,  character do
		TalentSwitch.sub(j, talents, active)
	end

end

function TalentSwitch.sub(j, talents, active)

	local tiers = MAX_NUM_TALENTS / 3
	local name, tex, body, flag = GetMacroInfo(j)

	local bbody = body --so we only update macros if theres an actual change we need a backup to compare to

	for i = 1, tiers do
		if active[i] ~= nil then
			
			for k = 1, 3 do
				if talents[i][k] ~= active[i] then

				local out_str = TalentSwitch.esc(talents[i][k])
				local in_str = TalentSwitch.esc(active[i])

-- evocation options
					if talents[i][k] == "Invocation" and tsParseEvocation==true then
						body=body:gsub("Evocation", in_str)
					elseif active[i] == "Invocation" and tsParseEvocation==true then
						body=body:gsub(out_str, "Evocation")
-- everything else
					else
--experimental
						body=TalentSwitch.do_custom(active[i], talents[i][k], body)
						body=body:gsub(out_str, in_str)
					end

				end
			end
		end
	end

	if bbody ~= body then --only if the macro has actually changed
		if string.len(body) < 256 then
			EditMacro(j, nil, nil, body)
		else
			print("TalentSwitch - ERROR: could not update macro "..name.." due to length constraints. ("..string.len(body).."/255)")
		end
	end
end

function TalentSwitch.doBars()

	local talents = {}
	for i = 1, 6 do
		talents[i] = {}
	end
	local active = {}

	local specGroup = GetActiveSpecGroup(); 

	for i = 1, MAX_NUM_TALENTS do
		local name, iconTexture, tier, column, selected, available = GetTalentInfo(i)

		if name then
			if selected then
				local spellLink = GetSpellLink(name)
		
				if spellLink then 
					local spellID = spellLink:match("spell:(%d+)")
					active[tier] = spellID
				end
	
			else
				table.insert(talents[tier], name)
			end
		end
	end
	

	for i = 1, 120 do
		local type, id, subtype = GetActionInfo(i)
		local name = GetSpellInfo(id)

		if type ~= "macro" and type ~= nil then
			for j = 1, 6 do

				if tLocs[specGroup][j][i] == true then -- if a saved slot now has a skill on it, we can no longer use it
					tLocs[specGroup][j][i] = nil
				end

				if ( active[j] ~= nil and (name == talents[j][1] or name == talents[j][2]) ) then

					local passive = IsPassiveSpell(active[j])
					
					if passive == nil then
						PickupAction(i)
						ClearCursor()
						PickupSpell(active[j])
						PlaceAction(i)

						name2 = GetSpellInfo(active[j])

						print("Replaced "..name.." with "..name2.." on button "..i..".")
					else
						PickupAction(i)
						ClearCursor()
						tLocs[specGroup][j][i] = true
						print("Passive talent selected, remembering that "..name.." was removed from button "..i..".")
					end
					break										-- no need to check further tiers if we match
				end
			end
		end

		if type == nil then -- check empty slots to see if they were saved for talents
			for j = 1, 6 do
				if tLocs[specGroup][j][i] == true and active[j] ~= nil then
					
					local passive = IsPassiveSpell(active[j])
					
					if passive == nil then
						PickupSpell(active[j])
						PlaceAction(i)

						name2 = GetSpellInfo(active[j])

						print("Placed "..name2.." on button "..i..".")
						tLocs[specGroup][j][i] = nil
					end
					break	
				end
			end
		end

	end

	ClearCursor()
--	print("Flashing")
--	TalentSwitch.doFlash()

end

local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent("PLAYER_TALENT_UPDATE")

local frame2 = CreateFrame("Frame")
frame2:SetScript("OnEvent", OnWrongEvent)
frame2:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")

local frame3 = CreateFrame("Frame")
frame3:SetScript("OnEvent", OnMacroChange)
frame3:RegisterEvent("UPDATE_MACROS")